# Name: time_degrees.py
#
# Authors: F. Tarissan
# Purpose: compute the degree of each nodes at each time
#
# Input : line : n1 n2 t "A"/"S" sorted by t
#            "A" = add
#            "S" = remove
#
# Output : t m deg(n1) deg(n2) ... deg(np)
####################################

import sys

#####################
# GENERAL FUNCTIONS #
#####################


# read from stdin
# comute degree for each time
# write on stdout

def compute_td(nb):

	deg={}
	lnodes=range(1,nb+1)

	m=0
	for i in lnodes:
		deg[i]=0
		
	current=0

	for line in sys.stdin:
		[n1,n2,t,k]= line.strip().split()
		t=int(t)
		n1=int(n1)
		n2=int(n2)

		if t!=current:
			sys.stdout.write("%d %d"%(current,m))
			for i in lnodes:
				sys.stdout.write(" %d"%deg[i])
			sys.stdout.write("\n")
			current=t

		if k=="A":
			deg[n1]=deg[n1]+1
			deg[n2]=deg[n2]+1
			m+=1
		else:
			deg[n1]=deg[n1]-1
			deg[n2]=deg[n2]-1
			m-=1

	# when end of file is reached
	sys.stdout.write("%d %d"%(current,m))
	for i in lnodes:
		sys.stdout.write(" %d"%deg[i])
	sys.stdout.write("\n")


# Main loop
if __name__ == '__main__':
	# handling arguments
	if len(sys.argv) != 2:
		sys.stderr.write("Usage: %s nb_nodes\n"%sys.argv[0])
		sys.exit(1)

	# read parameters
	nbnodes=int(sys.argv[1])
	
	# compute degrees
	compute_td(nbnodes)
